/*****************************************************************************
 *   rtctest.c:  main C entry file for Philips LPC214x Family Microprocessors
 *
 *   Copyright(C) 2006, Philips Semiconductor
 *   All rights reserved.
 *
 *   History
 *   2005.10.01  ver 1.00    Prelimnary version, first Release
 *
******************************************************************************/
#include <targets/LPC21xx.h>
#include "../common/inc/type.h"
#include "../common/inc/irq.h"
#include "rtc.h"

extern DWORD alarm_on;
RTCTime local_time, alarm_time, current_time;

/*****************************************************************************
**   Main Function  main()
******************************************************************************/
int main (void)
{	    	
    init_VIC();
    RTCInit();			        /* Initialize RTC module */

    local_time.RTC_Sec = 0;
    local_time.RTC_Min = 0;
    local_time.RTC_Hour = 0;
    local_time.RTC_Mday = 28;
    local_time.RTC_Wday = 7;
    local_time.RTC_Yday = 28;		/* current date 12/08/2005 */
    local_time.RTC_Mon = 5;
    local_time.RTC_Year = 2007;
    RTCSetTime( local_time );		/* Set local time */

    alarm_time.RTC_Sec =  10;	    // 10 Sekunden spter ein Alarm
    alarm_time.RTC_Min  = 0;
    alarm_time.RTC_Hour = 0;
    alarm_time.RTC_Mday = 28;
    alarm_time.RTC_Wday = 7;
    alarm_time.RTC_Yday = 28;		/* alarm date 01/01/2006 */
    alarm_time.RTC_Mon = 5;
    alarm_time.RTC_Year = 2007;
    RTCSetAlarm( alarm_time );		/* set alarm time */
   
    /* install RTC timer handler mainly for alarm control */
    if ( install_irq( RTC_INT, (void *)RTCHandler ) == FALSE )
    {
	while ( 1 );		/* very bad happened */
    }

    /* mask off alarm mask, turn on IMYEAR in the counter increment interrupt
    register */
    RTCSetAlarmMask(AMRSEC|AMRMIN|AMRHOUR|AMRDOM|AMRDOW|AMRDOY|AMRMON|AMRYEAR);
    //CIIR = IMMIN | IMYEAR;
    
    CIIR = IMMIN | IMSEC;
    CIIR = 0x00;
    AMR = 0xFE;
    /* 2006/01/01/00:00:00 is the alarm on */
    
    RTCStart();
    enableIRQ(); 
    CIIR = 0x01;
    while (1) 
    {					/* Loop forever */
	if ( alarm_on != 0 )
	{
	    alarm_on = 0;
	    /* Get current time when alarm is on */
	    current_time = RTCGetTime();	
	}
    }
    return 0;
}

/******************************************************************************
**                            End Of File
******************************************************************************/
